/* rygel-connection-manager.c generated by valac 0.26.0.92-9bcc61c, the Vala compiler
 * generated from rygel-connection-manager.vala, do not modify */

/*
 * Copyright (C) 2008 OpenedHand Ltd.
 * Copyright (C) 2008 Zeeshan Ali <zeenix@gmail.com>.
 *
 * Author: Jorn Baayen <jorn@openedhand.com>
 *         Zeeshan Ali <zeenix@gmail.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <libgupnp/gupnp.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define RYGEL_TYPE_CONNECTION_MANAGER (rygel_connection_manager_get_type ())
#define RYGEL_CONNECTION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_CONNECTION_MANAGER, RygelConnectionManager))
#define RYGEL_CONNECTION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_CONNECTION_MANAGER, RygelConnectionManagerClass))
#define RYGEL_IS_CONNECTION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_CONNECTION_MANAGER))
#define RYGEL_IS_CONNECTION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_CONNECTION_MANAGER))
#define RYGEL_CONNECTION_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_CONNECTION_MANAGER, RygelConnectionManagerClass))

typedef struct _RygelConnectionManager RygelConnectionManager;
typedef struct _RygelConnectionManagerClass RygelConnectionManagerClass;
typedef struct _RygelConnectionManagerPrivate RygelConnectionManagerPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _RygelConnectionManager {
	GUPnPService parent_instance;
	RygelConnectionManagerPrivate * priv;
	gchar* sink_protocol_info;
	gchar* connection_ids;
	gchar* source_protocol_info;
	gint rcs_id;
	gint av_transport_id;
	gchar* direction;
};

struct _RygelConnectionManagerClass {
	GUPnPServiceClass parent_class;
	gchar* (*get_current_protocol_info) (RygelConnectionManager* self);
};


static gpointer rygel_connection_manager_parent_class = NULL;

GType rygel_connection_manager_get_type (void) G_GNUC_CONST;
enum  {
	RYGEL_CONNECTION_MANAGER_DUMMY_PROPERTY
};
#define RYGEL_CONNECTION_MANAGER_UPNP_ID "urn:upnp-org:serviceId:ConnectionManager"
#define RYGEL_CONNECTION_MANAGER_UPNP_TYPE "urn:schemas-upnp-org:service:ConnectionManager:2"
#define RYGEL_CONNECTION_MANAGER_DESCRIPTION_PATH "xml/ConnectionManager.xml"
static void rygel_connection_manager_real_constructed (GObject* base);
static void rygel_connection_manager_query_source_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, const gchar* var, GValue* val);
static void _rygel_connection_manager_query_source_protocol_info_cb_gupnp_service_query_variable (GUPnPService* _sender, const gchar* variable, GValue* value, gpointer self);
static void rygel_connection_manager_query_sink_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, const gchar* var, GValue* val);
static void _rygel_connection_manager_query_sink_protocol_info_cb_gupnp_service_query_variable (GUPnPService* _sender, const gchar* variable, GValue* value, gpointer self);
static void rygel_connection_manager_query_current_connection_ids_cb (RygelConnectionManager* self, GUPnPService* cm, const gchar* var, GValue* val);
static void _rygel_connection_manager_query_current_connection_ids_cb_gupnp_service_query_variable (GUPnPService* _sender, const gchar* variable, GValue* value, gpointer self);
static void rygel_connection_manager_get_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action);
static void _rygel_connection_manager_get_protocol_info_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self);
static void rygel_connection_manager_get_current_connection_ids_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action);
static void _rygel_connection_manager_get_current_connection_ids_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self);
static void rygel_connection_manager_get_current_connection_info_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action);
static void _rygel_connection_manager_get_current_connection_info_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self);
gchar* rygel_connection_manager_get_current_protocol_info (RygelConnectionManager* self);
static gchar* rygel_connection_manager_real_get_current_protocol_info (RygelConnectionManager* self);
RygelConnectionManager* rygel_connection_manager_new (void);
RygelConnectionManager* rygel_connection_manager_construct (GType object_type);
static void rygel_connection_manager_finalize (GObject* obj);


static void _rygel_connection_manager_query_source_protocol_info_cb_gupnp_service_query_variable (GUPnPService* _sender, const gchar* variable, GValue* value, gpointer self) {
#line 52 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	rygel_connection_manager_query_source_protocol_info_cb ((RygelConnectionManager*) self, _sender, variable, value);
#line 98 "rygel-connection-manager.c"
}


static void _rygel_connection_manager_query_sink_protocol_info_cb_gupnp_service_query_variable (GUPnPService* _sender, const gchar* variable, GValue* value, gpointer self) {
#line 54 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	rygel_connection_manager_query_sink_protocol_info_cb ((RygelConnectionManager*) self, _sender, variable, value);
#line 105 "rygel-connection-manager.c"
}


static void _rygel_connection_manager_query_current_connection_ids_cb_gupnp_service_query_variable (GUPnPService* _sender, const gchar* variable, GValue* value, gpointer self) {
#line 56 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	rygel_connection_manager_query_current_connection_ids_cb ((RygelConnectionManager*) self, _sender, variable, value);
#line 112 "rygel-connection-manager.c"
}


static void _rygel_connection_manager_get_protocol_info_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self) {
#line 59 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	rygel_connection_manager_get_protocol_info_cb ((RygelConnectionManager*) self, _sender, action);
#line 119 "rygel-connection-manager.c"
}


static void _rygel_connection_manager_get_current_connection_ids_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self) {
#line 61 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	rygel_connection_manager_get_current_connection_ids_cb ((RygelConnectionManager*) self, _sender, action);
#line 126 "rygel-connection-manager.c"
}


static void _rygel_connection_manager_get_current_connection_info_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self) {
#line 63 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	rygel_connection_manager_get_current_connection_info_cb ((RygelConnectionManager*) self, _sender, action);
#line 133 "rygel-connection-manager.c"
}


static void rygel_connection_manager_real_constructed (GObject* base) {
	RygelConnectionManager * self;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
#line 45 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	self = (RygelConnectionManager*) base;
#line 46 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	G_OBJECT_CLASS (rygel_connection_manager_parent_class)->constructed ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gupnp_service_get_type (), GUPnPService));
#line 48 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp0_ = g_strdup ("");
#line 48 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_g_free0 (self->sink_protocol_info);
#line 48 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	self->sink_protocol_info = _tmp0_;
#line 49 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp1_ = g_strdup ("");
#line 49 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_g_free0 (self->source_protocol_info);
#line 49 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	self->source_protocol_info = _tmp1_;
#line 50 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp2_ = g_strdup ("0");
#line 50 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_g_free0 (self->connection_ids);
#line 50 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	self->connection_ids = _tmp2_;
#line 52 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "query-variable::SourceProtocolInfo", (GCallback) _rygel_connection_manager_query_source_protocol_info_cb_gupnp_service_query_variable, self, 0);
#line 54 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "query-variable::SinkProtocolInfo", (GCallback) _rygel_connection_manager_query_sink_protocol_info_cb_gupnp_service_query_variable, self, 0);
#line 56 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "query-variable::CurrentConnectionIDs", (GCallback) _rygel_connection_manager_query_current_connection_ids_cb_gupnp_service_query_variable, self, 0);
#line 59 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetProtocolInfo", (GCallback) _rygel_connection_manager_get_protocol_info_cb_gupnp_service_action_invoked, self, 0);
#line 61 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetCurrentConnectionIDs", (GCallback) _rygel_connection_manager_get_current_connection_ids_cb_gupnp_service_action_invoked, self, 0);
#line 63 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetCurrentConnectionInfo", (GCallback) _rygel_connection_manager_get_current_connection_info_cb_gupnp_service_action_invoked, self, 0);
#line 176 "rygel-connection-manager.c"
}


static gchar* rygel_connection_manager_real_get_current_protocol_info (RygelConnectionManager* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 68 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp0_ = g_strdup ("");
#line 68 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	result = _tmp0_;
#line 68 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	return result;
#line 189 "rygel-connection-manager.c"
}


gchar* rygel_connection_manager_get_current_protocol_info (RygelConnectionManager* self) {
#line 67 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	return RYGEL_CONNECTION_MANAGER_GET_CLASS (self)->get_current_protocol_info (self);
#line 198 "rygel-connection-manager.c"
}


static void rygel_connection_manager_query_source_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, const gchar* var, GValue* val) {
	const gchar* _tmp0_ = NULL;
#line 71 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 71 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 71 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (var != NULL);
#line 71 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (val != NULL);
#line 74 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_value_init (val, G_TYPE_STRING);
#line 75 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp0_ = self->source_protocol_info;
#line 75 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_value_set_string (val, _tmp0_);
#line 218 "rygel-connection-manager.c"
}


static void rygel_connection_manager_query_sink_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, const gchar* var, GValue* val) {
	const gchar* _tmp0_ = NULL;
#line 78 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 78 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 78 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (var != NULL);
#line 78 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (val != NULL);
#line 81 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_value_init (val, G_TYPE_STRING);
#line 82 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp0_ = self->sink_protocol_info;
#line 82 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_value_set_string (val, _tmp0_);
#line 238 "rygel-connection-manager.c"
}


static void rygel_connection_manager_query_current_connection_ids_cb (RygelConnectionManager* self, GUPnPService* cm, const gchar* var, GValue* val) {
	const gchar* _tmp0_ = NULL;
#line 85 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 85 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 85 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (var != NULL);
#line 85 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (val != NULL);
#line 88 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_value_init (val, G_TYPE_STRING);
#line 89 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp0_ = self->connection_ids;
#line 89 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_value_set_string (val, _tmp0_);
#line 258 "rygel-connection-manager.c"
}


static void rygel_connection_manager_get_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action) {
	GUPnPServiceAction* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	GUPnPServiceAction* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	GUPnPServiceAction* _tmp7_ = NULL;
#line 92 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 92 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 92 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (action != NULL);
#line 94 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp0_ = action;
#line 94 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp1_ = gupnp_service_action_get_argument_count (_tmp0_);
#line 94 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	if (_tmp1_ != ((guint) 0)) {
#line 281 "rygel-connection-manager.c"
		GUPnPServiceAction* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 95 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		_tmp2_ = action;
#line 95 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		_tmp3_ = _ ("Invalid argument");
#line 95 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		gupnp_service_action_return_error (_tmp2_, (guint) 402, _tmp3_);
#line 97 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		return;
#line 292 "rygel-connection-manager.c"
	}
#line 100 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp4_ = action;
#line 100 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp5_ = self->source_protocol_info;
#line 100 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp6_ = self->sink_protocol_info;
#line 100 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	gupnp_service_action_set (_tmp4_, "Source", G_TYPE_STRING, _tmp5_, "Sink", G_TYPE_STRING, _tmp6_, NULL);
#line 103 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp7_ = action;
#line 103 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	gupnp_service_action_return (_tmp7_);
#line 306 "rygel-connection-manager.c"
}


static void rygel_connection_manager_get_current_connection_ids_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action) {
	GUPnPServiceAction* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	GUPnPServiceAction* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	GUPnPServiceAction* _tmp6_ = NULL;
#line 106 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 106 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 106 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (action != NULL);
#line 108 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp0_ = action;
#line 108 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp1_ = gupnp_service_action_get_argument_count (_tmp0_);
#line 108 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	if (_tmp1_ != ((guint) 0)) {
#line 328 "rygel-connection-manager.c"
		GUPnPServiceAction* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 109 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		_tmp2_ = action;
#line 109 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		_tmp3_ = _ ("Invalid argument");
#line 109 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		gupnp_service_action_return_error (_tmp2_, (guint) 402, _tmp3_);
#line 111 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		return;
#line 339 "rygel-connection-manager.c"
	}
#line 114 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp4_ = action;
#line 114 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp5_ = self->connection_ids;
#line 114 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	gupnp_service_action_set (_tmp4_, "ConnectionIDs", G_TYPE_STRING, _tmp5_, NULL);
#line 116 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp6_ = action;
#line 116 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	gupnp_service_action_return (_tmp6_);
#line 351 "rygel-connection-manager.c"
}


static void rygel_connection_manager_get_current_connection_info_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action) {
	gchar* connection_id = NULL;
	GUPnPServiceAction* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp12_ = NULL;
	GUPnPServiceAction* _tmp15_ = NULL;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	const gchar* _tmp20_ = NULL;
	GUPnPServiceAction* _tmp21_ = NULL;
#line 119 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 119 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 119 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	g_return_if_fail (action != NULL);
#line 123 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp0_ = action;
#line 123 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	gupnp_service_action_get (_tmp0_, "ConnectionID", G_TYPE_STRING, &connection_id, NULL);
#line 124 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp3_ = connection_id;
#line 124 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	if (_tmp3_ == NULL) {
#line 124 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		_tmp2_ = TRUE;
#line 385 "rygel-connection-manager.c"
	} else {
		GUPnPServiceAction* _tmp4_ = NULL;
		guint _tmp5_ = 0U;
#line 124 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		_tmp4_ = action;
#line 124 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		_tmp5_ = gupnp_service_action_get_argument_count (_tmp4_);
#line 124 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		_tmp2_ = _tmp5_ != ((guint) 1);
#line 395 "rygel-connection-manager.c"
	}
#line 124 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	if (_tmp2_) {
#line 124 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		_tmp1_ = TRUE;
#line 401 "rygel-connection-manager.c"
	} else {
		gboolean _tmp6_ = FALSE;
		const gchar* _tmp7_ = NULL;
#line 125 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		_tmp7_ = connection_id;
#line 125 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		if (g_strcmp0 (_tmp7_, "0") != 0) {
#line 409 "rygel-connection-manager.c"
			const gchar* _tmp8_ = NULL;
			gint _tmp9_ = 0;
#line 125 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
			_tmp8_ = connection_id;
#line 125 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
			_tmp9_ = atoi (_tmp8_);
#line 125 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
			_tmp6_ = _tmp9_ == 0;
#line 418 "rygel-connection-manager.c"
		} else {
#line 125 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
			_tmp6_ = FALSE;
#line 422 "rygel-connection-manager.c"
		}
#line 125 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		_tmp1_ = _tmp6_;
#line 426 "rygel-connection-manager.c"
	}
#line 124 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	if (_tmp1_) {
#line 430 "rygel-connection-manager.c"
		GUPnPServiceAction* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
#line 126 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		_tmp10_ = action;
#line 126 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		_tmp11_ = _ ("Invalid argument");
#line 126 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		gupnp_service_action_return_error (_tmp10_, (guint) 402, _tmp11_);
#line 128 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		_g_free0 (connection_id);
#line 128 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		return;
#line 443 "rygel-connection-manager.c"
	}
#line 131 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp12_ = connection_id;
#line 131 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	if (g_strcmp0 (_tmp12_, "0") != 0) {
#line 449 "rygel-connection-manager.c"
		GUPnPServiceAction* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
#line 132 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		_tmp13_ = action;
#line 132 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		_tmp14_ = _ ("Invalid connection reference");
#line 132 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		gupnp_service_action_return_error (_tmp13_, (guint) 706, _tmp14_);
#line 134 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		_g_free0 (connection_id);
#line 134 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
		return;
#line 462 "rygel-connection-manager.c"
	}
#line 137 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp15_ = action;
#line 137 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp16_ = self->rcs_id;
#line 137 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp17_ = self->av_transport_id;
#line 137 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp18_ = rygel_connection_manager_get_current_protocol_info (self);
#line 137 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp19_ = _tmp18_;
#line 137 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp20_ = self->direction;
#line 137 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	gupnp_service_action_set (_tmp15_, "RcsID", G_TYPE_INT, _tmp16_, "AVTransportID", G_TYPE_INT, _tmp17_, "ProtocolInfo", G_TYPE_STRING, _tmp19_, "PeerConnectionManager", G_TYPE_STRING, "", "PeerConnectionID", G_TYPE_INT, -1, "Direction", G_TYPE_STRING, _tmp20_, "Status", G_TYPE_STRING, "OK", NULL);
#line 137 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_g_free0 (_tmp19_);
#line 159 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_tmp21_ = action;
#line 159 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	gupnp_service_action_return (_tmp21_);
#line 119 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_g_free0 (connection_id);
#line 486 "rygel-connection-manager.c"
}


RygelConnectionManager* rygel_connection_manager_construct (GType object_type) {
	RygelConnectionManager * self = NULL;
#line 31 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	self = (RygelConnectionManager*) g_object_new (object_type, NULL);
#line 31 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	return self;
#line 496 "rygel-connection-manager.c"
}


RygelConnectionManager* rygel_connection_manager_new (void) {
#line 31 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	return rygel_connection_manager_construct (RYGEL_TYPE_CONNECTION_MANAGER);
#line 503 "rygel-connection-manager.c"
}


static void rygel_connection_manager_class_init (RygelConnectionManagerClass * klass) {
#line 31 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	rygel_connection_manager_parent_class = g_type_class_peek_parent (klass);
#line 31 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	((GObjectClass *) klass)->constructed = rygel_connection_manager_real_constructed;
#line 31 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	((RygelConnectionManagerClass *) klass)->get_current_protocol_info = rygel_connection_manager_real_get_current_protocol_info;
#line 31 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_connection_manager_finalize;
#line 516 "rygel-connection-manager.c"
}


static void rygel_connection_manager_instance_init (RygelConnectionManager * self) {
}


static void rygel_connection_manager_finalize (GObject* obj) {
	RygelConnectionManager * self;
#line 31 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_CONNECTION_MANAGER, RygelConnectionManager);
#line 37 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_g_free0 (self->sink_protocol_info);
#line 38 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_g_free0 (self->connection_ids);
#line 39 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_g_free0 (self->source_protocol_info);
#line 43 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	_g_free0 (self->direction);
#line 31 "/home/jens/Source/rygel/src/librygel-core/rygel-connection-manager.vala"
	G_OBJECT_CLASS (rygel_connection_manager_parent_class)->finalize (obj);
#line 538 "rygel-connection-manager.c"
}


/**
 * Basic implementation of UPnP ConnectionManager service version 2.
 */
GType rygel_connection_manager_get_type (void) {
	static volatile gsize rygel_connection_manager_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_connection_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelConnectionManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_connection_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelConnectionManager), 0, (GInstanceInitFunc) rygel_connection_manager_instance_init, NULL };
		GType rygel_connection_manager_type_id;
		rygel_connection_manager_type_id = g_type_register_static (gupnp_service_get_type (), "RygelConnectionManager", &g_define_type_info, 0);
		g_once_init_leave (&rygel_connection_manager_type_id__volatile, rygel_connection_manager_type_id);
	}
	return rygel_connection_manager_type_id__volatile;
}



