/* rygel-default-player-controller.c generated by valac 0.26.0.92-9bcc61c, the Vala compiler
 * generated from rygel-default-player-controller.vala, do not modify */

/*
 * Copyright (C) 2012 Intel Corporation.
 * Copyright (C) 2014 Atlantic PuffinPack AB.
 *
 * Author: Richard Röjfors <richard@puffinpack.se>
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <libgupnp-av/gupnp-av.h>
#include <float.h>
#include <math.h>
#include <rygel-core.h>


#define RYGEL_TYPE_PLAYER_CONTROLLER (rygel_player_controller_get_type ())
#define RYGEL_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_PLAYER_CONTROLLER, RygelPlayerController))
#define RYGEL_IS_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_PLAYER_CONTROLLER))
#define RYGEL_PLAYER_CONTROLLER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), RYGEL_TYPE_PLAYER_CONTROLLER, RygelPlayerControllerIface))

typedef struct _RygelPlayerController RygelPlayerController;
typedef struct _RygelPlayerControllerIface RygelPlayerControllerIface;

#define RYGEL_TYPE_DEFAULT_PLAYER_CONTROLLER (rygel_default_player_controller_get_type ())
#define RYGEL_DEFAULT_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_DEFAULT_PLAYER_CONTROLLER, RygelDefaultPlayerController))
#define RYGEL_DEFAULT_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_DEFAULT_PLAYER_CONTROLLER, RygelDefaultPlayerControllerClass))
#define RYGEL_IS_DEFAULT_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_DEFAULT_PLAYER_CONTROLLER))
#define RYGEL_IS_DEFAULT_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_DEFAULT_PLAYER_CONTROLLER))
#define RYGEL_DEFAULT_PLAYER_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_DEFAULT_PLAYER_CONTROLLER, RygelDefaultPlayerControllerClass))

typedef struct _RygelDefaultPlayerController RygelDefaultPlayerController;
typedef struct _RygelDefaultPlayerControllerClass RygelDefaultPlayerControllerClass;
typedef struct _RygelDefaultPlayerControllerPrivate RygelDefaultPlayerControllerPrivate;

#define RYGEL_TYPE_MEDIA_PLAYER (rygel_media_player_get_type ())
#define RYGEL_MEDIA_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_MEDIA_PLAYER, RygelMediaPlayer))
#define RYGEL_IS_MEDIA_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_MEDIA_PLAYER))
#define RYGEL_MEDIA_PLAYER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), RYGEL_TYPE_MEDIA_PLAYER, RygelMediaPlayerIface))

typedef struct _RygelMediaPlayer RygelMediaPlayer;
typedef struct _RygelMediaPlayerIface RygelMediaPlayerIface;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _RygelPlayerControllerIface {
	GTypeInterface parent_iface;
	gboolean (*next) (RygelPlayerController* self);
	gboolean (*previous) (RygelPlayerController* self);
	void (*set_single_play_uri) (RygelPlayerController* self, const gchar* uri, const gchar* metadata, const gchar* mime, const gchar* features);
	void (*set_playlist_uri) (RygelPlayerController* self, const gchar* uri, const gchar* metadata, GUPnPMediaCollection* collection);
	void (*set_next_single_play_uri) (RygelPlayerController* self, const gchar* uri, const gchar* metadata, const gchar* mime, const gchar* features);
	void (*set_next_playlist_uri) (RygelPlayerController* self, const gchar* uri, const gchar* metadata, GUPnPMediaCollection* collection);
	gboolean (*is_play_mode_valid) (RygelPlayerController* self, const gchar* play_mode);
	const gchar* (*get_playback_state) (RygelPlayerController* self);
	void (*set_playback_state) (RygelPlayerController* self, const gchar* value);
	guint (*get_n_tracks) (RygelPlayerController* self);
	void (*set_n_tracks) (RygelPlayerController* self, guint value);
	guint (*get_track) (RygelPlayerController* self);
	void (*set_track) (RygelPlayerController* self, guint value);
	gchar* (*get_uri) (RygelPlayerController* self);
	void (*set_uri) (RygelPlayerController* self, const gchar* value);
	gchar* (*get_metadata) (RygelPlayerController* self);
	void (*set_metadata) (RygelPlayerController* self, const gchar* value);
	gchar* (*get_track_uri) (RygelPlayerController* self);
	void (*set_track_uri) (RygelPlayerController* self, const gchar* value);
	gchar* (*get_track_metadata) (RygelPlayerController* self);
	void (*set_track_metadata) (RygelPlayerController* self, const gchar* value);
	gchar* (*get_next_uri) (RygelPlayerController* self);
	void (*set_next_uri) (RygelPlayerController* self, const gchar* value);
	gchar* (*get_next_metadata) (RygelPlayerController* self);
	void (*set_next_metadata) (RygelPlayerController* self, const gchar* value);
	gchar* (*get_current_transport_actions) (RygelPlayerController* self);
	const gchar* (*get_play_mode) (RygelPlayerController* self);
	void (*set_play_mode) (RygelPlayerController* self, const gchar* value);
};

struct _RygelDefaultPlayerController {
	GObject parent_instance;
	RygelDefaultPlayerControllerPrivate * priv;
};

struct _RygelDefaultPlayerControllerClass {
	GObjectClass parent_class;
};

struct _RygelMediaPlayerIface {
	GTypeInterface parent_iface;
	gboolean (*seek) (RygelMediaPlayer* self, gint64 time);
	gboolean (*seek_bytes) (RygelMediaPlayer* self, gint64 bytes);
	gchar** (*get_protocols) (RygelMediaPlayer* self, int* result_length1);
	gchar** (*get_mime_types) (RygelMediaPlayer* self, int* result_length1);
	gchar* (*get_playback_state) (RygelMediaPlayer* self);
	void (*set_playback_state) (RygelMediaPlayer* self, const gchar* value);
	gchar** (*get_allowed_playback_speeds) (RygelMediaPlayer* self, int* result_length1);
	gchar* (*get_playback_speed) (RygelMediaPlayer* self);
	void (*set_playback_speed) (RygelMediaPlayer* self, const gchar* value);
	gchar* (*get_uri) (RygelMediaPlayer* self);
	void (*set_uri) (RygelMediaPlayer* self, const gchar* value);
	gdouble (*get_volume) (RygelMediaPlayer* self);
	void (*set_volume) (RygelMediaPlayer* self, gdouble value);
	gint64 (*get_duration) (RygelMediaPlayer* self);
	gint64 (*get_size) (RygelMediaPlayer* self);
	gchar* (*get_metadata) (RygelMediaPlayer* self);
	void (*set_metadata) (RygelMediaPlayer* self, const gchar* value);
	gchar* (*get_mime_type) (RygelMediaPlayer* self);
	void (*set_mime_type) (RygelMediaPlayer* self, const gchar* value);
	gboolean (*get_can_seek) (RygelMediaPlayer* self);
	gboolean (*get_can_seek_bytes) (RygelMediaPlayer* self);
	gchar* (*get_content_features) (RygelMediaPlayer* self);
	void (*set_content_features) (RygelMediaPlayer* self, const gchar* value);
	gint64 (*get_position) (RygelMediaPlayer* self);
	gint64 (*get_byte_position) (RygelMediaPlayer* self);
};

struct _RygelDefaultPlayerControllerPrivate {
	RygelMediaPlayer* _player;
	gchar* _protocol_info;
	gchar* _uri;
	gchar* _metadata;
	gchar* _next_uri;
	gchar* _next_metadata;
	GList* playlist;
	guint timeout_id;
	guint default_image_timeout;
	RygelConfiguration* config;
	gchar* next_features;
	gchar* next_mime;
	GUPnPMediaCollection* next_collection;
	guint _n_tracks;
	guint _track;
	gchar* _playback_state;
	gchar* _play_mode;
};


static gpointer rygel_default_player_controller_parent_class = NULL;
static RygelPlayerControllerIface* rygel_default_player_controller_rygel_player_controller_parent_iface = NULL;

GType rygel_player_controller_get_type (void) G_GNUC_CONST;
GType rygel_default_player_controller_get_type (void) G_GNUC_CONST;
GType rygel_media_player_get_type (void) G_GNUC_CONST;
#define RYGEL_DEFAULT_PLAYER_CONTROLLER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), RYGEL_TYPE_DEFAULT_PLAYER_CONTROLLER, RygelDefaultPlayerControllerPrivate))
enum  {
	RYGEL_DEFAULT_PLAYER_CONTROLLER_DUMMY_PROPERTY,
	RYGEL_DEFAULT_PLAYER_CONTROLLER_PLAYER,
	RYGEL_DEFAULT_PLAYER_CONTROLLER_PROTOCOL_INFO,
	RYGEL_DEFAULT_PLAYER_CONTROLLER_PLAYBACK_STATE,
	RYGEL_DEFAULT_PLAYER_CONTROLLER_N_TRACKS,
	RYGEL_DEFAULT_PLAYER_CONTROLLER_TRACK,
	RYGEL_DEFAULT_PLAYER_CONTROLLER_URI,
	RYGEL_DEFAULT_PLAYER_CONTROLLER_METADATA,
	RYGEL_DEFAULT_PLAYER_CONTROLLER_TRACK_URI,
	RYGEL_DEFAULT_PLAYER_CONTROLLER_TRACK_METADATA,
	RYGEL_DEFAULT_PLAYER_CONTROLLER_NEXT_URI,
	RYGEL_DEFAULT_PLAYER_CONTROLLER_NEXT_METADATA,
	RYGEL_DEFAULT_PLAYER_CONTROLLER_CURRENT_TRANSPORT_ACTIONS,
	RYGEL_DEFAULT_PLAYER_CONTROLLER_PLAY_MODE
};
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
#define RYGEL_DEFAULT_PLAYER_CONTROLLER_DEFAULT_IMAGE_TIMEOUT 15
#define RYGEL_DEFAULT_PLAYER_CONTROLLER_CONFIG_SECTION "Renderer"
#define RYGEL_DEFAULT_PLAYER_CONTROLLER_TIMEOUT_KEY "image-timeout"
#define RYGEL_DEFAULT_PLAYER_CONTROLLER_DIDL_FRAME_TEMPLATE "<DIDL-Lite " "xmlns:dc=\"http://purl.org/dc/elements/1.1/\" " "xmlns:upnp=\"urn:schemas-upnp-org:metadata-1-0/upnp/\" " "xmlns:dlna=\"urn:schemas-dlna-org:metadata-1-0/\" " "xmlns=\"urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/\">" "%s</DIDL-Lite>"
RygelDefaultPlayerController* rygel_default_player_controller_new (RygelMediaPlayer* player, const gchar* protocol_info);
RygelDefaultPlayerController* rygel_default_player_controller_construct (GType object_type, RygelMediaPlayer* player, const gchar* protocol_info);
static void rygel_default_player_controller_real_constructed (GObject* base);
static RygelMediaPlayer* rygel_default_player_controller_get_player (RygelDefaultPlayerController* self);
static void rygel_default_player_controller_notify_state_cb (RygelDefaultPlayerController* self, GObject* player, GParamSpec* p);
static void _rygel_default_player_controller_notify_state_cb_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void rygel_default_player_controller_notify_uri_cb (RygelDefaultPlayerController* self, GObject* player, GParamSpec* p);
static void _rygel_default_player_controller_notify_uri_cb_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void rygel_default_player_controller_notify_metadata_cb (RygelDefaultPlayerController* self, GObject* player, GParamSpec* p);
static void _rygel_default_player_controller_notify_metadata_cb_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void rygel_default_player_controller_on_setting_changed (RygelDefaultPlayerController* self, const gchar* section, const gchar* key);
static void _rygel_default_player_controller_on_setting_changed_rygel_configuration_setting_changed (RygelConfiguration* _sender, const gchar* section, const gchar* key, gpointer self);
static gboolean rygel_default_player_controller_real_next (RygelPlayerController* base);
guint rygel_player_controller_get_track (RygelPlayerController* self);
guint rygel_player_controller_get_n_tracks (RygelPlayerController* self);
void rygel_player_controller_set_track (RygelPlayerController* self, guint value);
gchar* rygel_player_controller_get_next_uri (RygelPlayerController* self);
void rygel_player_controller_set_playlist_uri (RygelPlayerController* self, const gchar* uri, const gchar* metadata, GUPnPMediaCollection* collection);
gchar* rygel_player_controller_get_next_metadata (RygelPlayerController* self);
void rygel_player_controller_set_single_play_uri (RygelPlayerController* self, const gchar* uri, const gchar* metadata, const gchar* mime, const gchar* features);
void rygel_player_controller_set_next_uri (RygelPlayerController* self, const gchar* value);
void rygel_player_controller_set_next_metadata (RygelPlayerController* self, const gchar* value);
static gboolean rygel_default_player_controller_real_previous (RygelPlayerController* base);
static void rygel_default_player_controller_real_set_single_play_uri (RygelPlayerController* base, const gchar* uri, const gchar* metadata, const gchar* mime, const gchar* features);
gchar* rygel_player_controller_unescape (RygelPlayerController* self, const gchar* input);
void rygel_player_controller_set_metadata (RygelPlayerController* self, const gchar* value);
void rygel_player_controller_set_uri (RygelPlayerController* self, const gchar* value);
void rygel_media_player_set_mime_type (RygelMediaPlayer* self, const gchar* value);
void rygel_media_player_set_content_features (RygelMediaPlayer* self, const gchar* value);
gchar* rygel_player_controller_get_metadata (RygelPlayerController* self);
void rygel_player_controller_set_track_metadata (RygelPlayerController* self, const gchar* value);
gchar* rygel_player_controller_get_uri (RygelPlayerController* self);
void rygel_player_controller_set_track_uri (RygelPlayerController* self, const gchar* value);
void rygel_player_controller_set_n_tracks (RygelPlayerController* self, guint value);
static void rygel_default_player_controller_real_set_playlist_uri (RygelPlayerController* base, const gchar* uri, const gchar* metadata, GUPnPMediaCollection* collection);
static void rygel_default_player_controller_apply_track (RygelDefaultPlayerController* self);
static void rygel_default_player_controller_real_set_next_single_play_uri (RygelPlayerController* base, const gchar* uri, const gchar* metadata, const gchar* mime, const gchar* features);
static void rygel_default_player_controller_real_set_next_playlist_uri (RygelPlayerController* base, const gchar* uri, const gchar* metadata, GUPnPMediaCollection* collection);
gchar* rygel_media_player_get_playback_state (RygelMediaPlayer* self);
static gboolean ___lambda5_ (RygelDefaultPlayerController* self);
gboolean rygel_player_controller_next (RygelPlayerController* self);
static void rygel_default_player_controller_reset (RygelDefaultPlayerController* self);
static gboolean ____lambda5__gsource_func (gpointer self);
static gboolean rygel_default_player_controller_real_is_play_mode_valid (RygelPlayerController* base, const gchar* play_mode);
static const gchar* rygel_default_player_controller_get_protocol_info (RygelDefaultPlayerController* self);
const gchar* rygel_player_controller_get_playback_state (RygelPlayerController* self);
static void rygel_default_player_controller_setup_image_timeouts (RygelDefaultPlayerController* self, glong lifetime);
void rygel_player_controller_set_playback_state (RygelPlayerController* self, const gchar* value);
static gboolean __lambda6_ (RygelDefaultPlayerController* self);
static gboolean ___lambda6__gsource_func (gpointer self);
static void rygel_default_player_controller_set_player (RygelDefaultPlayerController* self, RygelMediaPlayer* value);
static void rygel_default_player_controller_set_protocol_info (RygelDefaultPlayerController* self, const gchar* value);
void rygel_media_player_set_playback_state (RygelMediaPlayer* self, const gchar* value);
gchar* rygel_media_player_get_uri (RygelMediaPlayer* self);
void rygel_media_player_set_uri (RygelMediaPlayer* self, const gchar* value);
gchar* rygel_media_player_get_metadata (RygelMediaPlayer* self);
void rygel_media_player_set_metadata (RygelMediaPlayer* self, const gchar* value);
gboolean rygel_media_player_get_can_seek (RygelMediaPlayer* self);
gboolean rygel_media_player_get_can_seek_bytes (RygelMediaPlayer* self);
gchar** rygel_media_player_get_allowed_playback_speeds (RygelMediaPlayer* self, int* result_length1);
static void rygel_default_player_controller_finalize (GObject* obj);
gchar* rygel_player_controller_get_track_uri (RygelPlayerController* self);
gchar* rygel_player_controller_get_track_metadata (RygelPlayerController* self);
gchar* rygel_player_controller_get_current_transport_actions (RygelPlayerController* self);
const gchar* rygel_player_controller_get_play_mode (RygelPlayerController* self);
static void _vala_rygel_default_player_controller_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
void rygel_player_controller_set_play_mode (RygelPlayerController* self, const gchar* value);
static void _vala_rygel_default_player_controller_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static void _g_object_unref0_ (gpointer var) {
#line 193 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 262 "rygel-default-player-controller.c"
}


static void _g_list_free__g_object_unref0_ (GList* self) {
#line 193 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
#line 193 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_list_free (self);
#line 271 "rygel-default-player-controller.c"
}


RygelDefaultPlayerController* rygel_default_player_controller_construct (GType object_type, RygelMediaPlayer* player, const gchar* protocol_info) {
	RygelDefaultPlayerController * self = NULL;
	RygelMediaPlayer* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 208 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_val_if_fail (player != NULL, NULL);
#line 208 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_val_if_fail (protocol_info != NULL, NULL);
#line 209 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = player;
#line 209 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = protocol_info;
#line 209 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) g_object_new (object_type, "player", _tmp0_, "protocol-info", _tmp1_, NULL);
#line 208 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return self;
#line 291 "rygel-default-player-controller.c"
}


RygelDefaultPlayerController* rygel_default_player_controller_new (RygelMediaPlayer* player, const gchar* protocol_info) {
#line 208 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return rygel_default_player_controller_construct (RYGEL_TYPE_DEFAULT_PLAYER_CONTROLLER, player, protocol_info);
#line 298 "rygel-default-player-controller.c"
}


static void _rygel_default_player_controller_notify_state_cb_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 215 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_default_player_controller_notify_state_cb ((RygelDefaultPlayerController*) self, _sender, pspec);
#line 305 "rygel-default-player-controller.c"
}


static void _rygel_default_player_controller_notify_uri_cb_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 216 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_default_player_controller_notify_uri_cb ((RygelDefaultPlayerController*) self, _sender, pspec);
#line 312 "rygel-default-player-controller.c"
}


static void _rygel_default_player_controller_notify_metadata_cb_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 217 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_default_player_controller_notify_metadata_cb ((RygelDefaultPlayerController*) self, _sender, pspec);
#line 319 "rygel-default-player-controller.c"
}


static void _rygel_default_player_controller_on_setting_changed_rygel_configuration_setting_changed (RygelConfiguration* _sender, const gchar* section, const gchar* key, gpointer self) {
#line 220 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_default_player_controller_on_setting_changed ((RygelDefaultPlayerController*) self, section, key);
#line 326 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_real_constructed (GObject* base) {
	RygelDefaultPlayerController * self;
	RygelMediaPlayer* _tmp0_ = NULL;
	RygelMediaPlayer* _tmp1_ = NULL;
	RygelMediaPlayer* _tmp2_ = NULL;
	RygelMetaConfig* _tmp3_ = NULL;
	RygelConfiguration* _tmp4_ = NULL;
#line 212 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 213 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	G_OBJECT_CLASS (rygel_default_player_controller_parent_class)->constructed (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject));
#line 215 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->_player;
#line 215 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_signal_connect_object ((GObject*) _tmp0_, "notify::playback-state", (GCallback) _rygel_default_player_controller_notify_state_cb_g_object_notify, self, 0);
#line 216 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = self->priv->_player;
#line 216 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_signal_connect_object ((GObject*) _tmp1_, "notify::uri", (GCallback) _rygel_default_player_controller_notify_uri_cb_g_object_notify, self, 0);
#line 217 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp2_ = self->priv->_player;
#line 217 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_signal_connect_object ((GObject*) _tmp2_, "notify::metadata", (GCallback) _rygel_default_player_controller_notify_metadata_cb_g_object_notify, self, 0);
#line 219 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp3_ = rygel_meta_config_get_default ();
#line 219 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_object_unref0 (self->priv->config);
#line 219 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->config = (RygelConfiguration*) _tmp3_;
#line 220 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp4_ = self->priv->config;
#line 220 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_signal_connect_object (_tmp4_, "setting-changed", (GCallback) _rygel_default_player_controller_on_setting_changed_rygel_configuration_setting_changed, self, 0);
#line 221 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->default_image_timeout = (guint) RYGEL_DEFAULT_PLAYER_CONTROLLER_DEFAULT_IMAGE_TIMEOUT;
#line 222 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_default_player_controller_on_setting_changed (self, RYGEL_DEFAULT_PLAYER_CONTROLLER_CONFIG_SECTION, RYGEL_DEFAULT_PLAYER_CONTROLLER_TIMEOUT_KEY);
#line 367 "rygel-default-player-controller.c"
}


static gboolean rygel_default_player_controller_real_next (RygelPlayerController* base) {
	RygelDefaultPlayerController * self;
	gboolean result = FALSE;
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	guint _tmp3_ = 0U;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
#line 225 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 227 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = rygel_player_controller_get_track ((RygelPlayerController*) self);
#line 227 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = _tmp0_;
#line 227 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp2_ = rygel_player_controller_get_n_tracks ((RygelPlayerController*) self);
#line 227 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp3_ = _tmp2_;
#line 227 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp1_ < _tmp3_) {
#line 394 "rygel-default-player-controller.c"
		guint _tmp4_ = 0U;
		guint _tmp5_ = 0U;
#line 228 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp4_ = rygel_player_controller_get_track ((RygelPlayerController*) self);
#line 228 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp5_ = _tmp4_;
#line 228 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_track ((RygelPlayerController*) self, _tmp5_ + 1);
#line 230 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		result = TRUE;
#line 230 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		return result;
#line 407 "rygel-default-player-controller.c"
	}
#line 234 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp6_ = rygel_player_controller_get_next_uri ((RygelPlayerController*) self);
#line 234 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp7_ = _tmp6_;
#line 234 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp8_ = _tmp7_;
#line 234 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp9_ = g_strcmp0 (_tmp8_, "") != 0;
#line 234 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (_tmp8_);
#line 234 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp9_) {
#line 421 "rygel-default-player-controller.c"
		GUPnPMediaCollection* _tmp10_ = NULL;
#line 235 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp10_ = self->priv->next_collection;
#line 235 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		if (_tmp10_ != NULL) {
#line 427 "rygel-default-player-controller.c"
			gchar* _tmp11_ = NULL;
			gchar* _tmp12_ = NULL;
			gchar* _tmp13_ = NULL;
			gchar* _tmp14_ = NULL;
			gchar* _tmp15_ = NULL;
			gchar* _tmp16_ = NULL;
			GUPnPMediaCollection* _tmp17_ = NULL;
#line 236 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp11_ = rygel_player_controller_get_next_uri ((RygelPlayerController*) self);
#line 236 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp12_ = _tmp11_;
#line 236 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp13_ = _tmp12_;
#line 236 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp14_ = rygel_player_controller_get_next_metadata ((RygelPlayerController*) self);
#line 236 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp15_ = _tmp14_;
#line 236 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp16_ = _tmp15_;
#line 236 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp17_ = self->priv->next_collection;
#line 236 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			rygel_player_controller_set_playlist_uri ((RygelPlayerController*) self, _tmp13_, _tmp16_, _tmp17_);
#line 236 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_g_free0 (_tmp16_);
#line 236 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_g_free0 (_tmp13_);
#line 455 "rygel-default-player-controller.c"
		} else {
			gchar* _tmp18_ = NULL;
			gchar* _tmp19_ = NULL;
			gchar* _tmp20_ = NULL;
			gchar* _tmp21_ = NULL;
			gchar* _tmp22_ = NULL;
			gchar* _tmp23_ = NULL;
			const gchar* _tmp24_ = NULL;
			const gchar* _tmp25_ = NULL;
#line 240 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp18_ = rygel_player_controller_get_next_uri ((RygelPlayerController*) self);
#line 240 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp19_ = _tmp18_;
#line 240 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp20_ = _tmp19_;
#line 240 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp21_ = rygel_player_controller_get_next_metadata ((RygelPlayerController*) self);
#line 240 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp22_ = _tmp21_;
#line 240 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp23_ = _tmp22_;
#line 240 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp24_ = self->priv->next_mime;
#line 240 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp25_ = self->priv->next_features;
#line 240 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			rygel_player_controller_set_single_play_uri ((RygelPlayerController*) self, _tmp20_, _tmp23_, _tmp24_, _tmp25_);
#line 240 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_g_free0 (_tmp23_);
#line 240 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_g_free0 (_tmp20_);
#line 487 "rygel-default-player-controller.c"
		}
#line 246 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_next_uri ((RygelPlayerController*) self, "");
#line 247 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_next_metadata ((RygelPlayerController*) self, "");
#line 248 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_free0 (self->priv->next_mime);
#line 248 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		self->priv->next_mime = NULL;
#line 249 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_free0 (self->priv->next_features);
#line 249 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		self->priv->next_features = NULL;
#line 250 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_object_unref0 (self->priv->next_collection);
#line 250 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		self->priv->next_collection = NULL;
#line 252 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		result = TRUE;
#line 252 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		return result;
#line 509 "rygel-default-player-controller.c"
	}
#line 255 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	result = FALSE;
#line 255 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 515 "rygel-default-player-controller.c"
}


static gboolean rygel_default_player_controller_real_previous (RygelPlayerController* base) {
	RygelDefaultPlayerController * self;
	gboolean result = FALSE;
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
	guint _tmp2_ = 0U;
	guint _tmp3_ = 0U;
#line 258 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 259 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = rygel_player_controller_get_track ((RygelPlayerController*) self);
#line 259 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = _tmp0_;
#line 259 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp1_ <= ((guint) 1)) {
#line 260 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		result = FALSE;
#line 260 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		return result;
#line 538 "rygel-default-player-controller.c"
	}
#line 263 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp2_ = rygel_player_controller_get_track ((RygelPlayerController*) self);
#line 263 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp3_ = _tmp2_;
#line 263 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_player_controller_set_track ((RygelPlayerController*) self, _tmp3_ - 1);
#line 265 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	result = TRUE;
#line 265 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 550 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_real_set_single_play_uri (RygelPlayerController* base, const gchar* uri, const gchar* metadata, const gchar* mime, const gchar* features) {
	RygelDefaultPlayerController * self;
	guint _tmp0_ = 0U;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	RygelMediaPlayer* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	RygelMediaPlayer* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	gboolean _tmp21_ = FALSE;
#line 268 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 268 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (uri != NULL);
#line 268 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (metadata != NULL);
#line 273 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->timeout_id;
#line 273 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp0_ != ((guint) 0)) {
#line 587 "rygel-default-player-controller.c"
		guint _tmp1_ = 0U;
#line 274 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp1_ = self->priv->timeout_id;
#line 274 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_source_remove (_tmp1_);
#line 275 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		self->priv->timeout_id = (guint) 0;
#line 595 "rygel-default-player-controller.c"
	}
#line 278 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp2_ = metadata;
#line 278 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp3_ = rygel_player_controller_unescape ((RygelPlayerController*) self, _tmp2_);
#line 278 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp4_ = _tmp3_;
#line 278 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_player_controller_set_metadata ((RygelPlayerController*) self, _tmp4_);
#line 278 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (_tmp4_);
#line 279 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp5_ = uri;
#line 279 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_player_controller_set_uri ((RygelPlayerController*) self, _tmp5_);
#line 281 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp7_ = mime;
#line 281 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp6_ = _tmp7_;
#line 281 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp6_ == NULL) {
#line 281 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp6_ = "";
#line 619 "rygel-default-player-controller.c"
	}
#line 281 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp8_ = self->priv->_player;
#line 281 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_media_player_set_mime_type (_tmp8_, _tmp6_);
#line 282 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp10_ = features;
#line 282 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp9_ = _tmp10_;
#line 282 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp9_ == NULL) {
#line 282 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp9_ = "*";
#line 633 "rygel-default-player-controller.c"
	}
#line 282 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp11_ = self->priv->_player;
#line 282 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_media_player_set_content_features (_tmp11_, _tmp9_);
#line 284 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp12_ = rygel_player_controller_get_metadata ((RygelPlayerController*) self);
#line 284 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp13_ = _tmp12_;
#line 284 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp14_ = _tmp13_;
#line 284 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_player_controller_set_track_metadata ((RygelPlayerController*) self, _tmp14_);
#line 284 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (_tmp14_);
#line 285 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp15_ = rygel_player_controller_get_uri ((RygelPlayerController*) self);
#line 285 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp16_ = _tmp15_;
#line 285 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp17_ = _tmp16_;
#line 285 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_player_controller_set_track_uri ((RygelPlayerController*) self, _tmp17_);
#line 285 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (_tmp17_);
#line 287 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	__g_list_free__g_object_unref0_0 (self->priv->playlist);
#line 287 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->playlist = NULL;
#line 289 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp18_ = rygel_player_controller_get_uri ((RygelPlayerController*) self);
#line 289 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp19_ = _tmp18_;
#line 289 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp20_ = _tmp19_;
#line 289 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp21_ = g_strcmp0 (_tmp20_, "") == 0;
#line 289 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (_tmp20_);
#line 289 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp21_) {
#line 290 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_n_tracks ((RygelPlayerController*) self, (guint) 0);
#line 291 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_track ((RygelPlayerController*) self, (guint) 0);
#line 679 "rygel-default-player-controller.c"
	} else {
#line 293 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_n_tracks ((RygelPlayerController*) self, (guint) 1);
#line 294 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_track ((RygelPlayerController*) self, (guint) 1);
#line 685 "rygel-default-player-controller.c"
	}
}


static void rygel_default_player_controller_real_set_playlist_uri (RygelPlayerController* base, const gchar* uri, const gchar* metadata, GUPnPMediaCollection* collection) {
	RygelDefaultPlayerController * self;
	guint _tmp0_ = 0U;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	GUPnPMediaCollection* _tmp6_ = NULL;
	GList* _tmp7_ = NULL;
	GList* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	gboolean need_notify = FALSE;
	guint _tmp10_ = 0U;
	guint _tmp11_ = 0U;
	gboolean _tmp12_ = FALSE;
#line 298 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 298 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (uri != NULL);
#line 298 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (metadata != NULL);
#line 298 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (collection != NULL);
#line 301 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->timeout_id;
#line 301 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp0_ != ((guint) 0)) {
#line 717 "rygel-default-player-controller.c"
		guint _tmp1_ = 0U;
#line 302 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp1_ = self->priv->timeout_id;
#line 302 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_source_remove (_tmp1_);
#line 303 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		self->priv->timeout_id = (guint) 0;
#line 725 "rygel-default-player-controller.c"
	}
#line 306 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp2_ = metadata;
#line 306 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp3_ = rygel_player_controller_unescape ((RygelPlayerController*) self, _tmp2_);
#line 306 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp4_ = _tmp3_;
#line 306 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_player_controller_set_metadata ((RygelPlayerController*) self, _tmp4_);
#line 306 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (_tmp4_);
#line 307 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp5_ = uri;
#line 307 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_player_controller_set_uri ((RygelPlayerController*) self, _tmp5_);
#line 309 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp6_ = collection;
#line 309 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp7_ = gupnp_media_collection_get_items (_tmp6_);
#line 309 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	__g_list_free__g_object_unref0_0 (self->priv->playlist);
#line 309 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->playlist = _tmp7_;
#line 310 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp8_ = self->priv->playlist;
#line 310 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp9_ = g_list_length (_tmp8_);
#line 310 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_player_controller_set_n_tracks ((RygelPlayerController*) self, _tmp9_);
#line 314 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp10_ = rygel_player_controller_get_track ((RygelPlayerController*) self);
#line 314 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp11_ = _tmp10_;
#line 314 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	need_notify = _tmp11_ != ((guint) 1);
#line 315 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->_track = (guint) 1;
#line 316 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_default_player_controller_apply_track (self);
#line 317 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp12_ = need_notify;
#line 317 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp12_) {
#line 318 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_object_notify ((GObject*) self, "track");
#line 771 "rygel-default-player-controller.c"
	}
}


static void rygel_default_player_controller_real_set_next_single_play_uri (RygelPlayerController* base, const gchar* uri, const gchar* metadata, const gchar* mime, const gchar* features) {
	RygelDefaultPlayerController * self;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
#line 322 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 322 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (uri != NULL);
#line 322 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (metadata != NULL);
#line 326 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = uri;
#line 326 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_player_controller_set_next_uri ((RygelPlayerController*) self, _tmp0_);
#line 327 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = metadata;
#line 327 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_player_controller_set_next_metadata ((RygelPlayerController*) self, _tmp1_);
#line 328 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp2_ = mime;
#line 328 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 328 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->next_mime);
#line 328 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->next_mime = _tmp3_;
#line 329 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp4_ = features;
#line 329 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 329 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->next_features);
#line 329 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->next_features = _tmp5_;
#line 330 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_object_unref0 (self->priv->next_collection);
#line 330 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->next_collection = NULL;
#line 818 "rygel-default-player-controller.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 340 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return self ? g_object_ref (self) : NULL;
#line 825 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_real_set_next_playlist_uri (RygelPlayerController* base, const gchar* uri, const gchar* metadata, GUPnPMediaCollection* collection) {
	RygelDefaultPlayerController * self;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GUPnPMediaCollection* _tmp2_ = NULL;
	GUPnPMediaCollection* _tmp3_ = NULL;
#line 333 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 333 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (uri != NULL);
#line 333 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (metadata != NULL);
#line 333 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (collection != NULL);
#line 336 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = uri;
#line 336 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_player_controller_set_next_uri ((RygelPlayerController*) self, _tmp0_);
#line 337 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = metadata;
#line 337 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_player_controller_set_next_metadata ((RygelPlayerController*) self, _tmp1_);
#line 338 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->next_mime);
#line 338 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->next_mime = NULL;
#line 339 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->next_features);
#line 339 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->next_features = NULL;
#line 340 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp2_ = collection;
#line 340 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 340 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_object_unref0 (self->priv->next_collection);
#line 340 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->next_collection = _tmp3_;
#line 867 "rygel-default-player-controller.c"
}


static gboolean ___lambda5_ (RygelDefaultPlayerController* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 348 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = rygel_player_controller_next ((RygelPlayerController*) self);
#line 348 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (!_tmp0_) {
#line 349 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_default_player_controller_reset (self);
#line 880 "rygel-default-player-controller.c"
	}
#line 352 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	result = FALSE;
#line 352 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 886 "rygel-default-player-controller.c"
}


static gboolean ____lambda5__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda5_ ((RygelDefaultPlayerController*) self);
#line 347 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 895 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_notify_state_cb (RygelDefaultPlayerController* self, GObject* player, GParamSpec* p) {
	gchar* state = NULL;
	RygelMediaPlayer* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
#line 343 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (self != NULL);
#line 343 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (player != NULL);
#line 343 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (p != NULL);
#line 344 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->_player;
#line 344 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = rygel_media_player_get_playback_state (_tmp0_);
#line 344 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp2_ = _tmp1_;
#line 344 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	state = _tmp2_;
#line 345 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp3_ = state;
#line 345 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (g_strcmp0 (_tmp3_, "EOS") == 0) {
#line 347 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda5__gsource_func, g_object_ref (self), g_object_unref);
#line 925 "rygel-default-player-controller.c"
	} else {
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
#line 354 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp4_ = self->priv->_playback_state;
#line 354 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp5_ = state;
#line 354 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		if (g_strcmp0 (_tmp4_, _tmp5_) != 0) {
#line 935 "rygel-default-player-controller.c"
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
#line 356 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp6_ = state;
#line 356 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp7_ = g_strdup (_tmp6_);
#line 356 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_g_free0 (self->priv->_playback_state);
#line 356 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			self->priv->_playback_state = _tmp7_;
#line 357 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			g_object_notify ((GObject*) self, "playback-state");
#line 948 "rygel-default-player-controller.c"
		}
	}
#line 343 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (state);
#line 953 "rygel-default-player-controller.c"
}


static gboolean rygel_default_player_controller_real_is_play_mode_valid (RygelPlayerController* base, const gchar* play_mode) {
	RygelDefaultPlayerController * self;
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
#line 361 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 361 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_val_if_fail (play_mode != NULL, FALSE);
#line 362 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = play_mode;
#line 362 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	result = g_strcmp0 (_tmp0_, "NORMAL") == 0;
#line 362 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 971 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_notify_uri_cb (RygelDefaultPlayerController* self, GObject* player, GParamSpec* p) {
#line 365 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (self != NULL);
#line 365 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (player != NULL);
#line 365 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (p != NULL);
#line 366 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_notify ((GObject*) self, "track-uri");
#line 984 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_notify_metadata_cb (RygelDefaultPlayerController* self, GObject* player, GParamSpec* p) {
#line 369 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (self != NULL);
#line 369 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (player != NULL);
#line 369 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (p != NULL);
#line 370 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_notify ((GObject*) self, "track-metadata");
#line 997 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_apply_track (RygelDefaultPlayerController* self) {
	GList* _tmp0_ = NULL;
#line 373 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (self != NULL);
#line 375 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->playlist;
#line 375 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp0_ != NULL) {
#line 1009 "rygel-default-player-controller.c"
		GUPnPDIDLLiteItem* item = NULL;
		GList* _tmp1_ = NULL;
		guint _tmp2_ = 0U;
		guint _tmp3_ = 0U;
		GList* _tmp4_ = NULL;
		gconstpointer _tmp5_ = NULL;
		GUPnPDIDLLiteItem* _tmp6_ = NULL;
		GUPnPDIDLLiteResource* res = NULL;
		GUPnPDIDLLiteItem* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		GUPnPDIDLLiteResource* _tmp9_ = NULL;
		GUPnPDIDLLiteItem* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		GUPnPDIDLLiteResource* _tmp15_ = NULL;
		const gchar* _tmp16_ = NULL;
		gboolean _tmp17_ = FALSE;
		GUPnPDIDLLiteItem* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
		gboolean _tmp21_ = FALSE;
#line 376 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp1_ = self->priv->playlist;
#line 376 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp2_ = rygel_player_controller_get_track ((RygelPlayerController*) self);
#line 376 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp3_ = _tmp2_;
#line 376 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp4_ = g_list_nth (_tmp1_, _tmp3_ - 1);
#line 376 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp5_ = _tmp4_->data;
#line 376 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp6_ = _g_object_ref0 ((GUPnPDIDLLiteItem*) _tmp5_);
#line 376 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		item = _tmp6_;
#line 378 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp7_ = item;
#line 378 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp8_ = self->priv->_protocol_info;
#line 378 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp9_ = gupnp_didl_lite_object_get_compat_resource ((GUPnPDIDLLiteObject*) _tmp7_, _tmp8_, TRUE);
#line 378 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		res = _tmp9_;
#line 379 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp10_ = item;
#line 379 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp11_ = gupnp_didl_lite_object_get_xml_string ((GUPnPDIDLLiteObject*) _tmp10_);
#line 379 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp12_ = _tmp11_;
#line 379 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp13_ = g_strdup_printf (RYGEL_DEFAULT_PLAYER_CONTROLLER_DIDL_FRAME_TEMPLATE, _tmp12_);
#line 379 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp14_ = _tmp13_;
#line 379 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_track_metadata ((RygelPlayerController*) self, _tmp14_);
#line 379 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_free0 (_tmp14_);
#line 379 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_free0 (_tmp12_);
#line 381 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp15_ = res;
#line 381 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp16_ = gupnp_didl_lite_resource_get_uri (_tmp15_);
#line 381 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_track_uri ((RygelPlayerController*) self, _tmp16_);
#line 383 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp18_ = item;
#line 383 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp19_ = gupnp_didl_lite_object_get_upnp_class ((GUPnPDIDLLiteObject*) _tmp18_);
#line 383 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp20_ = _tmp19_;
#line 383 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp21_ = g_str_has_prefix (_tmp20_, "object.item.image");
#line 383 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		if (_tmp21_) {
#line 1087 "rygel-default-player-controller.c"
			const gchar* _tmp22_ = NULL;
			const gchar* _tmp23_ = NULL;
#line 384 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp22_ = rygel_player_controller_get_playback_state ((RygelPlayerController*) self);
#line 384 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp23_ = _tmp22_;
#line 384 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp17_ = g_strcmp0 (_tmp23_, "STOPPED") != 0;
#line 1096 "rygel-default-player-controller.c"
		} else {
#line 383 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp17_ = FALSE;
#line 1100 "rygel-default-player-controller.c"
		}
#line 383 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		if (_tmp17_) {
#line 1104 "rygel-default-player-controller.c"
			GUPnPDIDLLiteItem* _tmp24_ = NULL;
			glong _tmp25_ = 0L;
			glong _tmp26_ = 0L;
#line 385 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp24_ = item;
#line 385 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp25_ = gupnp_didl_lite_item_get_lifetime (_tmp24_);
#line 385 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			_tmp26_ = _tmp25_;
#line 385 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			rygel_default_player_controller_setup_image_timeouts (self, _tmp26_);
#line 1116 "rygel-default-player-controller.c"
		}
#line 375 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_object_unref0 (res);
#line 375 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_object_unref0 (item);
#line 1122 "rygel-default-player-controller.c"
	}
}


static void rygel_default_player_controller_reset (RygelDefaultPlayerController* self) {
#line 390 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (self != NULL);
#line 391 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_player_controller_set_playback_state ((RygelPlayerController*) self, "STOPPED");
#line 392 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_player_controller_set_track ((RygelPlayerController*) self, (guint) 1);
#line 1134 "rygel-default-player-controller.c"
}


static gboolean __lambda6_ (RygelDefaultPlayerController* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 411 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->timeout_id = (guint) 0;
#line 412 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = rygel_player_controller_next ((RygelPlayerController*) self);
#line 412 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (!_tmp0_) {
#line 413 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_default_player_controller_reset (self);
#line 1149 "rygel-default-player-controller.c"
	}
#line 416 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	result = FALSE;
#line 416 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 1155 "rygel-default-player-controller.c"
}


static gboolean ___lambda6__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda6_ ((RygelDefaultPlayerController*) self);
#line 410 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 1164 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_setup_image_timeouts (RygelDefaultPlayerController* self, glong lifetime) {
	guint timeout = 0U;
	guint _tmp0_ = 0U;
	glong _tmp1_ = 0L;
	guint _tmp3_ = 0U;
	guint _tmp4_ = 0U;
	guint _tmp6_ = 0U;
	guint _tmp7_ = 0U;
#line 395 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (self != NULL);
#line 399 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->default_image_timeout;
#line 399 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	timeout = _tmp0_;
#line 400 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = lifetime;
#line 400 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp1_ > ((glong) 0)) {
#line 1186 "rygel-default-player-controller.c"
		glong _tmp2_ = 0L;
#line 401 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp2_ = lifetime;
#line 401 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		timeout = (guint) _tmp2_;
#line 1192 "rygel-default-player-controller.c"
	}
#line 404 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp3_ = timeout;
#line 404 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_debug ("rygel-default-player-controller.vala:404: Item is image, setup timer: " \
"%ld", (glong) _tmp3_);
#line 406 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp4_ = self->priv->timeout_id;
#line 406 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp4_ != ((guint) 0)) {
#line 1202 "rygel-default-player-controller.c"
		guint _tmp5_ = 0U;
#line 407 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp5_ = self->priv->timeout_id;
#line 407 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_source_remove (_tmp5_);
#line 1208 "rygel-default-player-controller.c"
	}
#line 410 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp6_ = timeout;
#line 410 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp7_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) _tmp6_, ___lambda6__gsource_func, g_object_ref (self), g_object_unref);
#line 410 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->timeout_id = _tmp7_;
#line 1216 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_on_setting_changed (RygelDefaultPlayerController* self, const gchar* section, const gchar* key) {
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	guint _tmp6_ = 0U;
	GError * _inner_error_ = NULL;
#line 420 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (self != NULL);
#line 420 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (section != NULL);
#line 420 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (key != NULL);
#line 421 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = section;
#line 421 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (g_strcmp0 (_tmp1_, RYGEL_DEFAULT_PLAYER_CONTROLLER_CONFIG_SECTION) != 0) {
#line 1235 "rygel-default-player-controller.c"
		const gchar* _tmp2_ = NULL;
#line 421 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp2_ = key;
#line 421 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, RYGEL_DEFAULT_PLAYER_CONTROLLER_TIMEOUT_KEY) != 0;
#line 1241 "rygel-default-player-controller.c"
	} else {
#line 421 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp0_ = FALSE;
#line 1245 "rygel-default-player-controller.c"
	}
#line 421 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp0_) {
#line 422 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		return;
#line 1251 "rygel-default-player-controller.c"
	}
	{
		gint _tmp3_ = 0;
		RygelConfiguration* _tmp4_ = NULL;
		gint _tmp5_ = 0;
#line 426 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp4_ = self->priv->config;
#line 426 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp5_ = rygel_configuration_get_int (_tmp4_, RYGEL_DEFAULT_PLAYER_CONTROLLER_CONFIG_SECTION, RYGEL_DEFAULT_PLAYER_CONTROLLER_TIMEOUT_KEY, 0, G_MAXINT, &_inner_error_);
#line 426 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp3_ = _tmp5_;
#line 426 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1265 "rygel-default-player-controller.c"
			goto __catch4_g_error;
		}
#line 426 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		self->priv->default_image_timeout = (guint) _tmp3_;
#line 1270 "rygel-default-player-controller.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* _error_ = NULL;
#line 425 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_error_ = _inner_error_;
#line 425 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_inner_error_ = NULL;
#line 431 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		self->priv->default_image_timeout = (guint) RYGEL_DEFAULT_PLAYER_CONTROLLER_DEFAULT_IMAGE_TIMEOUT;
#line 425 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_error_free0 (_error_);
#line 1284 "rygel-default-player-controller.c"
	}
	__finally4:
#line 425 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 425 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 425 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_clear_error (&_inner_error_);
#line 425 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		return;
#line 1295 "rygel-default-player-controller.c"
	}
#line 434 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp6_ = self->priv->default_image_timeout;
#line 434 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_debug ("rygel-default-player-controller.vala:434: New image timeout: %lu", (gulong) _tmp6_);
#line 1301 "rygel-default-player-controller.c"
}


static RygelMediaPlayer* rygel_default_player_controller_get_player (RygelDefaultPlayerController* self) {
	RygelMediaPlayer* result;
	RygelMediaPlayer* _tmp0_ = NULL;
#line 51 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->_player;
#line 51 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	result = _tmp0_;
#line 51 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 1316 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_set_player (RygelDefaultPlayerController* self, RygelMediaPlayer* value) {
	RygelMediaPlayer* _tmp0_ = NULL;
	RygelMediaPlayer* _tmp1_ = NULL;
#line 51 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (self != NULL);
#line 51 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = value;
#line 51 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 51 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_object_unref0 (self->priv->_player);
#line 51 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->_player = _tmp1_;
#line 51 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_notify ((GObject *) self, "player");
#line 1335 "rygel-default-player-controller.c"
}


static const gchar* rygel_default_player_controller_get_protocol_info (RygelDefaultPlayerController* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 52 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->_protocol_info;
#line 52 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	result = _tmp0_;
#line 52 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 1350 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_set_protocol_info (RygelDefaultPlayerController* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 52 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_return_if_fail (self != NULL);
#line 52 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = value;
#line 52 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 52 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->_protocol_info);
#line 52 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->_protocol_info = _tmp1_;
#line 52 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_notify ((GObject *) self, "protocol-info");
#line 1369 "rygel-default-player-controller.c"
}


static const gchar* rygel_default_player_controller_real_get_playback_state (RygelPlayerController* base) {
	const gchar* result;
	RygelDefaultPlayerController* self;
	const gchar* _tmp0_ = NULL;
#line 60 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 60 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->_playback_state;
#line 60 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	result = _tmp0_;
#line 60 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 1385 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_real_set_playback_state (RygelPlayerController* base, const gchar* value) {
	RygelDefaultPlayerController* self;
	RygelMediaPlayer* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 61 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 61 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->_player;
#line 61 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = value;
#line 61 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_media_player_set_playback_state (_tmp0_, _tmp1_);
#line 1401 "rygel-default-player-controller.c"
}


static guint rygel_default_player_controller_real_get_n_tracks (RygelPlayerController* base) {
	guint result;
	RygelDefaultPlayerController* self;
	guint _tmp0_ = 0U;
#line 66 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 66 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->_n_tracks;
#line 66 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	result = _tmp0_;
#line 66 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 1417 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_real_set_n_tracks (RygelPlayerController* base, guint value) {
	RygelDefaultPlayerController* self;
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
#line 67 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 68 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = value;
#line 68 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = self->priv->_n_tracks;
#line 68 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp0_ != _tmp1_) {
#line 1433 "rygel-default-player-controller.c"
		guint _tmp2_ = 0U;
#line 69 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp2_ = value;
#line 69 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		self->priv->_n_tracks = _tmp2_;
#line 70 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_object_notify ((GObject*) self, "n-tracks");
#line 1441 "rygel-default-player-controller.c"
	}
}


static guint rygel_default_player_controller_real_get_track (RygelPlayerController* base) {
	guint result;
	RygelDefaultPlayerController* self;
	guint _tmp0_ = 0U;
#line 78 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 78 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->_track;
#line 78 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	result = _tmp0_;
#line 78 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 1458 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_real_set_track (RygelPlayerController* base, guint value) {
	RygelDefaultPlayerController* self;
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
#line 79 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 80 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = value;
#line 80 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = self->priv->_track;
#line 80 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp0_ != _tmp1_) {
#line 1474 "rygel-default-player-controller.c"
		guint _tmp2_ = 0U;
#line 81 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp2_ = value;
#line 81 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		self->priv->_track = _tmp2_;
#line 82 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_default_player_controller_apply_track (self);
#line 83 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_object_notify ((GObject*) self, "track");
#line 1484 "rygel-default-player-controller.c"
	}
}


static gchar* rygel_default_player_controller_real_get_uri (RygelPlayerController* base) {
	gchar* result;
	RygelDefaultPlayerController* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 89 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 89 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->_uri;
#line 89 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 89 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	result = _tmp1_;
#line 89 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 1504 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_real_set_uri (RygelPlayerController* base, const gchar* value) {
	RygelDefaultPlayerController* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 89 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 89 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = value;
#line 89 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 89 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->_uri);
#line 89 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->_uri = _tmp1_;
#line 89 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_notify ((GObject *) self, "uri");
#line 1524 "rygel-default-player-controller.c"
}


static gchar* rygel_default_player_controller_real_get_metadata (RygelPlayerController* base) {
	gchar* result;
	RygelDefaultPlayerController* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 90 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 90 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->_metadata;
#line 90 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 90 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	result = _tmp1_;
#line 90 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 1543 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_real_set_metadata (RygelPlayerController* base, const gchar* value) {
	RygelDefaultPlayerController* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 90 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 90 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = value;
#line 90 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 90 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->_metadata);
#line 90 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->_metadata = _tmp1_;
#line 90 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_notify ((GObject *) self, "metadata");
#line 1563 "rygel-default-player-controller.c"
}


static gchar* rygel_default_player_controller_real_get_track_uri (RygelPlayerController* base) {
	gchar* result;
	RygelDefaultPlayerController* self;
	RygelMediaPlayer* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 94 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 95 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->_player;
#line 95 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = rygel_media_player_get_uri (_tmp0_);
#line 95 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp2_ = _tmp1_;
#line 95 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp3_ = _tmp2_;
#line 95 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp4_ = _tmp3_ != NULL;
#line 95 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (_tmp3_);
#line 95 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp4_) {
#line 1591 "rygel-default-player-controller.c"
		RygelMediaPlayer* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
#line 96 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp5_ = self->priv->_player;
#line 96 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp6_ = rygel_media_player_get_uri (_tmp5_);
#line 96 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp7_ = _tmp6_;
#line 96 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp8_ = _tmp7_;
#line 96 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp9_ = g_markup_escape_text (_tmp8_, (gssize) (-1));
#line 96 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp10_ = _tmp9_;
#line 96 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_free0 (_tmp8_);
#line 96 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		result = _tmp10_;
#line 96 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		return result;
#line 1616 "rygel-default-player-controller.c"
	} else {
		gchar* _tmp11_ = NULL;
#line 98 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp11_ = g_strdup ("");
#line 98 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		result = _tmp11_;
#line 98 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		return result;
#line 1625 "rygel-default-player-controller.c"
	}
}


static void rygel_default_player_controller_real_set_track_uri (RygelPlayerController* base, const gchar* value) {
	RygelDefaultPlayerController* self;
	RygelMediaPlayer* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 102 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 103 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->_player;
#line 103 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = value;
#line 103 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_media_player_set_uri (_tmp0_, _tmp1_);
#line 1642 "rygel-default-player-controller.c"
}


static gchar* rygel_default_player_controller_real_get_track_metadata (RygelPlayerController* base) {
	gchar* result;
	RygelDefaultPlayerController* self;
	gchar* _tmp0_ = NULL;
	RygelMediaPlayer* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp5_ = NULL;
#line 109 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 109 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = self->priv->_player;
#line 109 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp2_ = rygel_media_player_get_metadata (_tmp1_);
#line 109 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp3_ = _tmp2_;
#line 109 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = _tmp3_;
#line 109 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp0_ == NULL) {
#line 1666 "rygel-default-player-controller.c"
		gchar* _tmp4_ = NULL;
#line 109 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp4_ = g_strdup ("");
#line 109 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_free0 (_tmp0_);
#line 109 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp0_ = _tmp4_;
#line 1674 "rygel-default-player-controller.c"
	}
#line 109 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp5_ = _tmp0_;
#line 109 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = NULL;
#line 109 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	result = _tmp5_;
#line 109 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (_tmp0_);
#line 109 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 1686 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_real_set_track_metadata (RygelPlayerController* base, const gchar* value) {
	RygelDefaultPlayerController* self;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 111 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 112 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = value;
#line 112 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = g_str_has_prefix (_tmp0_, "&lt;");
#line 112 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp1_) {
#line 1702 "rygel-default-player-controller.c"
		RygelMediaPlayer* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
#line 113 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp2_ = self->priv->_player;
#line 113 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp3_ = value;
#line 113 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp4_ = rygel_player_controller_unescape ((RygelPlayerController*) self, _tmp3_);
#line 113 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp5_ = _tmp4_;
#line 113 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_media_player_set_metadata (_tmp2_, _tmp5_);
#line 113 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_free0 (_tmp5_);
#line 1719 "rygel-default-player-controller.c"
	} else {
		RygelMediaPlayer* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
#line 115 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp6_ = self->priv->_player;
#line 115 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp7_ = value;
#line 115 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_media_player_set_metadata (_tmp6_, _tmp7_);
#line 1729 "rygel-default-player-controller.c"
	}
}


static gchar* rygel_default_player_controller_real_get_next_uri (RygelPlayerController* base) {
	gchar* result;
	RygelDefaultPlayerController* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 120 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 120 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->_next_uri;
#line 120 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 120 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	result = _tmp1_;
#line 120 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 1749 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_real_set_next_uri (RygelPlayerController* base, const gchar* value) {
	RygelDefaultPlayerController* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 120 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 120 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = value;
#line 120 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 120 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->_next_uri);
#line 120 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->_next_uri = _tmp1_;
#line 120 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_notify ((GObject *) self, "next-uri");
#line 1769 "rygel-default-player-controller.c"
}


static gchar* rygel_default_player_controller_real_get_next_metadata (RygelPlayerController* base) {
	gchar* result;
	RygelDefaultPlayerController* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 121 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 121 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->_next_metadata;
#line 121 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 121 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	result = _tmp1_;
#line 121 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 1788 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_real_set_next_metadata (RygelPlayerController* base, const gchar* value) {
	RygelDefaultPlayerController* self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 121 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 121 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = value;
#line 121 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 121 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->_next_metadata);
#line 121 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->_next_metadata = _tmp1_;
#line 121 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_notify ((GObject *) self, "next-metadata");
#line 1808 "rygel-default-player-controller.c"
}


static gchar* rygel_default_player_controller_real_get_current_transport_actions (RygelPlayerController* base) {
	gchar* result;
	RygelDefaultPlayerController* self;
	gchar* actions = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GQuark _tmp4_ = 0U;
#line 126 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	static GQuark _tmp3_label0 = 0;
#line 126 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	static GQuark _tmp3_label1 = 0;
#line 126 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	static GQuark _tmp3_label2 = 0;
#line 126 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	static GQuark _tmp3_label3 = 0;
#line 1828 "rygel-default-player-controller.c"
	const gchar* _tmp8_ = NULL;
	guint _tmp10_ = 0U;
	guint _tmp11_ = 0U;
	guint _tmp12_ = 0U;
	guint _tmp13_ = 0U;
	guint _tmp16_ = 0U;
	guint _tmp17_ = 0U;
	RygelMediaPlayer* _tmp20_ = NULL;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp25_ = FALSE;
	const gchar* _tmp26_ = NULL;
	gboolean _tmp32_ = FALSE;
	const gchar* _tmp33_ = NULL;
#line 124 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 125 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	actions = NULL;
#line 126 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = rygel_player_controller_get_playback_state ((RygelPlayerController*) self);
#line 126 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = _tmp0_;
#line 126 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp2_ = _tmp1_;
#line 126 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
#line 126 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if ((_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("PLAYING")))) || (_tmp4_ == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("TRANSITIONING"))))) {
#line 126 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		switch (0) {
#line 1859 "rygel-default-player-controller.c"
			default:
			{
				gchar* _tmp5_ = NULL;
#line 129 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
				_tmp5_ = g_strdup ("Stop,Seek,Pause");
#line 129 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
				_g_free0 (actions);
#line 129 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
				actions = _tmp5_;
#line 130 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
				break;
#line 1871 "rygel-default-player-controller.c"
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string ("STOPPED")))) {
#line 126 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		switch (0) {
#line 1877 "rygel-default-player-controller.c"
			default:
			{
				gchar* _tmp6_ = NULL;
#line 132 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
				_tmp6_ = g_strdup ("Play");
#line 132 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
				_g_free0 (actions);
#line 132 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
				actions = _tmp6_;
#line 133 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
				break;
#line 1889 "rygel-default-player-controller.c"
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label3) ? _tmp3_label3 : (_tmp3_label3 = g_quark_from_static_string ("PAUSED_PLAYBACK")))) {
#line 126 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		switch (0) {
#line 1895 "rygel-default-player-controller.c"
			default:
			{
				gchar* _tmp7_ = NULL;
#line 135 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
				_tmp7_ = g_strdup ("Stop,Play,Seek");
#line 135 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
				_g_free0 (actions);
#line 135 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
				actions = _tmp7_;
#line 136 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
				break;
#line 1907 "rygel-default-player-controller.c"
			}
		}
	} else {
#line 126 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		switch (0) {
#line 1913 "rygel-default-player-controller.c"
			default:
			{
#line 138 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
				break;
#line 1918 "rygel-default-player-controller.c"
			}
		}
	}
#line 141 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp8_ = actions;
#line 141 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp8_ == NULL) {
#line 1926 "rygel-default-player-controller.c"
		gchar* _tmp9_ = NULL;
#line 142 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp9_ = g_strdup ("");
#line 142 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		result = _tmp9_;
#line 142 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_free0 (actions);
#line 142 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		return result;
#line 1936 "rygel-default-player-controller.c"
	}
#line 145 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp10_ = rygel_player_controller_get_track ((RygelPlayerController*) self);
#line 145 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp11_ = _tmp10_;
#line 145 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp12_ = rygel_player_controller_get_n_tracks ((RygelPlayerController*) self);
#line 145 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp13_ = _tmp12_;
#line 145 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp11_ < _tmp13_) {
#line 1948 "rygel-default-player-controller.c"
		const gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
#line 146 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp14_ = actions;
#line 146 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp15_ = g_strconcat (_tmp14_, ",Next", NULL);
#line 146 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_free0 (actions);
#line 146 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		actions = _tmp15_;
#line 1959 "rygel-default-player-controller.c"
	}
#line 148 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp16_ = rygel_player_controller_get_track ((RygelPlayerController*) self);
#line 148 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp17_ = _tmp16_;
#line 148 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp17_ > ((guint) 1)) {
#line 1967 "rygel-default-player-controller.c"
		const gchar* _tmp18_ = NULL;
		gchar* _tmp19_ = NULL;
#line 149 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp18_ = actions;
#line 149 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp19_ = g_strconcat (_tmp18_, ",Previous", NULL);
#line 149 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_free0 (actions);
#line 149 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		actions = _tmp19_;
#line 1978 "rygel-default-player-controller.c"
	}
#line 152 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp20_ = self->priv->_player;
#line 152 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp21_ = rygel_media_player_get_can_seek (_tmp20_);
#line 152 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp22_ = _tmp21_;
#line 152 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp22_) {
#line 1988 "rygel-default-player-controller.c"
		const gchar* _tmp23_ = NULL;
		gchar* _tmp24_ = NULL;
#line 153 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp23_ = actions;
#line 153 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp24_ = g_strconcat (_tmp23_, ",X_DLNA_SeekTime", NULL);
#line 153 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_free0 (actions);
#line 153 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		actions = _tmp24_;
#line 1999 "rygel-default-player-controller.c"
	}
#line 155 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp26_ = actions;
#line 155 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp26_ != NULL) {
#line 2005 "rygel-default-player-controller.c"
		RygelMediaPlayer* _tmp27_ = NULL;
		gboolean _tmp28_ = FALSE;
		gboolean _tmp29_ = FALSE;
#line 155 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp27_ = self->priv->_player;
#line 155 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp28_ = rygel_media_player_get_can_seek_bytes (_tmp27_);
#line 155 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp29_ = _tmp28_;
#line 155 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp25_ = _tmp29_;
#line 2017 "rygel-default-player-controller.c"
	} else {
#line 155 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp25_ = FALSE;
#line 2021 "rygel-default-player-controller.c"
	}
#line 155 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp25_) {
#line 2025 "rygel-default-player-controller.c"
		const gchar* _tmp30_ = NULL;
		gchar* _tmp31_ = NULL;
#line 156 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp30_ = actions;
#line 156 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp31_ = g_strconcat (_tmp30_, ",X_DLNA_SeekByte", NULL);
#line 156 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_free0 (actions);
#line 156 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		actions = _tmp31_;
#line 2036 "rygel-default-player-controller.c"
	}
#line 159 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp33_ = actions;
#line 159 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp33_ != NULL) {
#line 2042 "rygel-default-player-controller.c"
		RygelMediaPlayer* _tmp34_ = NULL;
		gchar** _tmp35_ = NULL;
		gint _tmp35__length1 = 0;
		gchar** _tmp36_ = NULL;
		gint _tmp36__length1 = 0;
		gchar** _tmp37_ = NULL;
		gint _tmp37__length1 = 0;
#line 160 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp34_ = self->priv->_player;
#line 160 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp35_ = rygel_media_player_get_allowed_playback_speeds (_tmp34_, &_tmp35__length1);
#line 160 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp36_ = _tmp35_;
#line 160 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp36__length1 = _tmp35__length1;
#line 160 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp37_ = _tmp36_;
#line 160 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp37__length1 = _tmp36__length1;
#line 160 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp32_ = _tmp36__length1 > 1;
#line 160 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp37_ = (_vala_array_free (_tmp37_, _tmp37__length1, (GDestroyNotify) g_free), NULL);
#line 2066 "rygel-default-player-controller.c"
	} else {
#line 159 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp32_ = FALSE;
#line 2070 "rygel-default-player-controller.c"
	}
#line 159 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (_tmp32_) {
#line 2074 "rygel-default-player-controller.c"
		gchar* play_speeds = NULL;
		gchar* _tmp38_ = NULL;
		RygelMediaPlayer* _tmp39_ = NULL;
		gchar** _tmp40_ = NULL;
		gint _tmp40__length1 = 0;
		gchar** _tmp41_ = NULL;
		gint _tmp41__length1 = 0;
		const gchar* _tmp52_ = NULL;
		const gchar* _tmp53_ = NULL;
		gchar* _tmp54_ = NULL;
#line 161 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp38_ = g_strdup ("");
#line 161 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		play_speeds = _tmp38_;
#line 162 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp39_ = self->priv->_player;
#line 162 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp40_ = rygel_media_player_get_allowed_playback_speeds (_tmp39_, &_tmp40__length1);
#line 162 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp41_ = _tmp40_;
#line 162 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp41__length1 = _tmp40__length1;
#line 2097 "rygel-default-player-controller.c"
		{
			gchar** speed_collection = NULL;
			gint speed_collection_length1 = 0;
			gint _speed_collection_size_ = 0;
			gint speed_it = 0;
#line 162 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			speed_collection = _tmp41_;
#line 162 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			speed_collection_length1 = _tmp41__length1;
#line 162 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			for (speed_it = 0; speed_it < _tmp41__length1; speed_it = speed_it + 1) {
#line 2109 "rygel-default-player-controller.c"
				gchar* _tmp42_ = NULL;
				gchar* speed = NULL;
#line 162 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
				_tmp42_ = g_strdup (speed_collection[speed_it]);
#line 162 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
				speed = _tmp42_;
#line 2116 "rygel-default-player-controller.c"
				{
					const gchar* _tmp43_ = NULL;
#line 163 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
					_tmp43_ = speed;
#line 163 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
					if (g_strcmp0 (_tmp43_, "1") != 0) {
#line 2123 "rygel-default-player-controller.c"
						const gchar* _tmp44_ = NULL;
#line 164 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
						_tmp44_ = play_speeds;
#line 164 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
						if (g_strcmp0 (_tmp44_, "") == 0) {
#line 2129 "rygel-default-player-controller.c"
							const gchar* _tmp45_ = NULL;
							gchar* _tmp46_ = NULL;
#line 165 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
							_tmp45_ = speed;
#line 165 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
							_tmp46_ = g_strconcat (",X_DLNA_PS=", _tmp45_, NULL);
#line 165 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
							_g_free0 (play_speeds);
#line 165 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
							play_speeds = _tmp46_;
#line 2140 "rygel-default-player-controller.c"
						} else {
							const gchar* _tmp47_ = NULL;
							const gchar* _tmp48_ = NULL;
							gchar* _tmp49_ = NULL;
							gchar* _tmp50_ = NULL;
							gchar* _tmp51_ = NULL;
#line 167 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
							_tmp47_ = play_speeds;
#line 167 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
							_tmp48_ = speed;
#line 167 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
							_tmp49_ = g_strconcat ("\\,", _tmp48_, NULL);
#line 167 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
							_tmp50_ = _tmp49_;
#line 167 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
							_tmp51_ = g_strconcat (_tmp47_, _tmp50_, NULL);
#line 167 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
							_g_free0 (play_speeds);
#line 167 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
							play_speeds = _tmp51_;
#line 167 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
							_g_free0 (_tmp50_);
#line 2163 "rygel-default-player-controller.c"
						}
					}
#line 162 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
					_g_free0 (speed);
#line 2168 "rygel-default-player-controller.c"
				}
			}
#line 162 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
			speed_collection = (_vala_array_free (speed_collection, speed_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2173 "rygel-default-player-controller.c"
		}
#line 171 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp52_ = actions;
#line 171 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp53_ = play_speeds;
#line 171 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp54_ = g_strconcat (_tmp52_, _tmp53_, NULL);
#line 171 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_free0 (actions);
#line 171 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		actions = _tmp54_;
#line 159 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_free0 (play_speeds);
#line 2187 "rygel-default-player-controller.c"
	}
#line 174 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	result = actions;
#line 174 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 2193 "rygel-default-player-controller.c"
}


static const gchar* rygel_default_player_controller_real_get_play_mode (RygelPlayerController* base) {
	const gchar* result;
	RygelDefaultPlayerController* self;
	const gchar* _tmp0_ = NULL;
#line 180 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 181 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = self->priv->_play_mode;
#line 181 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	result = _tmp0_;
#line 181 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	return result;
#line 2209 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_real_set_play_mode (RygelPlayerController* base, const gchar* value) {
	RygelDefaultPlayerController* self;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 184 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = (RygelDefaultPlayerController*) base;
#line 185 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = value;
#line 185 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = self->priv->_play_mode;
#line 185 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	if (g_strcmp0 (_tmp0_, _tmp1_) != 0) {
#line 2225 "rygel-default-player-controller.c"
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
#line 186 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp2_ = value;
#line 186 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_tmp3_ = g_strdup (_tmp2_);
#line 186 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		_g_free0 (self->priv->_play_mode);
#line 186 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		self->priv->_play_mode = _tmp3_;
#line 187 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_object_notify ((GObject*) self, "play-mode");
#line 2238 "rygel-default-player-controller.c"
	}
}


static void rygel_default_player_controller_class_init (RygelDefaultPlayerControllerClass * klass) {
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_default_player_controller_parent_class = g_type_class_peek_parent (klass);
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_type_class_add_private (klass, sizeof (RygelDefaultPlayerControllerPrivate));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	((GObjectClass *) klass)->constructed = rygel_default_player_controller_real_constructed;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_rygel_default_player_controller_get_property;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_rygel_default_player_controller_set_property;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	G_OBJECT_CLASS (klass)->finalize = rygel_default_player_controller_finalize;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_DEFAULT_PLAYER_CONTROLLER_PLAYER, g_param_spec_object ("player", "player", "player", RYGEL_TYPE_MEDIA_PLAYER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_DEFAULT_PLAYER_CONTROLLER_PROTOCOL_INFO, g_param_spec_string ("protocol-info", "protocol-info", "protocol-info", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_DEFAULT_PLAYER_CONTROLLER_PLAYBACK_STATE, g_param_spec_string ("playback-state", "playback-state", "playback-state", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_DEFAULT_PLAYER_CONTROLLER_N_TRACKS, g_param_spec_uint ("n-tracks", "n-tracks", "n-tracks", 0, G_MAXUINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_DEFAULT_PLAYER_CONTROLLER_TRACK, g_param_spec_uint ("track", "track", "track", 0, G_MAXUINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_DEFAULT_PLAYER_CONTROLLER_URI, g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_DEFAULT_PLAYER_CONTROLLER_METADATA, g_param_spec_string ("metadata", "metadata", "metadata", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_DEFAULT_PLAYER_CONTROLLER_TRACK_URI, g_param_spec_string ("track-uri", "track-uri", "track-uri", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_DEFAULT_PLAYER_CONTROLLER_TRACK_METADATA, g_param_spec_string ("track-metadata", "track-metadata", "track-metadata", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_DEFAULT_PLAYER_CONTROLLER_NEXT_URI, g_param_spec_string ("next-uri", "next-uri", "next-uri", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_DEFAULT_PLAYER_CONTROLLER_NEXT_METADATA, g_param_spec_string ("next-metadata", "next-metadata", "next-metadata", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_DEFAULT_PLAYER_CONTROLLER_CURRENT_TRANSPORT_ACTIONS, g_param_spec_string ("current-transport-actions", "current-transport-actions", "current-transport-actions", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), RYGEL_DEFAULT_PLAYER_CONTROLLER_PLAY_MODE, g_param_spec_string ("play-mode", "play-mode", "play-mode", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2282 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_rygel_player_controller_interface_init (RygelPlayerControllerIface * iface) {
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	rygel_default_player_controller_rygel_player_controller_parent_iface = g_type_interface_peek_parent (iface);
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->next = (gboolean (*)(RygelPlayerController*)) rygel_default_player_controller_real_next;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->previous = (gboolean (*)(RygelPlayerController*)) rygel_default_player_controller_real_previous;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->set_single_play_uri = (void (*)(RygelPlayerController*, const gchar*, const gchar*, const gchar*, const gchar*)) rygel_default_player_controller_real_set_single_play_uri;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->set_playlist_uri = (void (*)(RygelPlayerController*, const gchar*, const gchar*, GUPnPMediaCollection*)) rygel_default_player_controller_real_set_playlist_uri;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->set_next_single_play_uri = (void (*)(RygelPlayerController*, const gchar*, const gchar*, const gchar*, const gchar*)) rygel_default_player_controller_real_set_next_single_play_uri;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->set_next_playlist_uri = (void (*)(RygelPlayerController*, const gchar*, const gchar*, GUPnPMediaCollection*)) rygel_default_player_controller_real_set_next_playlist_uri;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->is_play_mode_valid = (gboolean (*)(RygelPlayerController*, const gchar*)) rygel_default_player_controller_real_is_play_mode_valid;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->get_playback_state = rygel_default_player_controller_real_get_playback_state;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->set_playback_state = rygel_default_player_controller_real_set_playback_state;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->get_n_tracks = rygel_default_player_controller_real_get_n_tracks;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->set_n_tracks = rygel_default_player_controller_real_set_n_tracks;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->get_track = rygel_default_player_controller_real_get_track;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->set_track = rygel_default_player_controller_real_set_track;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->get_uri = rygel_default_player_controller_real_get_uri;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->set_uri = rygel_default_player_controller_real_set_uri;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->get_metadata = rygel_default_player_controller_real_get_metadata;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->set_metadata = rygel_default_player_controller_real_set_metadata;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->get_track_uri = rygel_default_player_controller_real_get_track_uri;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->set_track_uri = rygel_default_player_controller_real_set_track_uri;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->get_track_metadata = rygel_default_player_controller_real_get_track_metadata;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->set_track_metadata = rygel_default_player_controller_real_set_track_metadata;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->get_next_uri = rygel_default_player_controller_real_get_next_uri;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->set_next_uri = rygel_default_player_controller_real_set_next_uri;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->get_next_metadata = rygel_default_player_controller_real_get_next_metadata;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->set_next_metadata = rygel_default_player_controller_real_set_next_metadata;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->get_current_transport_actions = rygel_default_player_controller_real_get_current_transport_actions;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->get_play_mode = rygel_default_player_controller_real_get_play_mode;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	iface->set_play_mode = rygel_default_player_controller_real_set_play_mode;
#line 2345 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_instance_init (RygelDefaultPlayerController * self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv = RYGEL_DEFAULT_PLAYER_CONTROLLER_GET_PRIVATE (self);
#line 89 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp0_ = g_strdup ("");
#line 89 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->_uri = _tmp0_;
#line 90 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp1_ = g_strdup ("");
#line 90 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->_metadata = _tmp1_;
#line 120 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp2_ = g_strdup ("");
#line 120 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->_next_uri = _tmp2_;
#line 121 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp3_ = g_strdup ("");
#line 121 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->_next_metadata = _tmp3_;
#line 205 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp4_ = g_strdup ("NO_MEDIA_PRESENT");
#line 205 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->_playback_state = _tmp4_;
#line 206 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_tmp5_ = g_strdup ("NORMAL");
#line 206 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self->priv->_play_mode = _tmp5_;
#line 2382 "rygel-default-player-controller.c"
}


static void rygel_default_player_controller_finalize (GObject* obj) {
	RygelDefaultPlayerController * self;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, RYGEL_TYPE_DEFAULT_PLAYER_CONTROLLER, RygelDefaultPlayerController);
#line 51 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_object_unref0 (self->priv->_player);
#line 52 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->_protocol_info);
#line 89 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->_uri);
#line 90 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->_metadata);
#line 120 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->_next_uri);
#line 121 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->_next_metadata);
#line 193 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	__g_list_free__g_object_unref0_0 (self->priv->playlist);
#line 196 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_object_unref0 (self->priv->config);
#line 198 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->next_features);
#line 199 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->next_mime);
#line 200 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_object_unref0 (self->priv->next_collection);
#line 205 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->_playback_state);
#line 206 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	_g_free0 (self->priv->_play_mode);
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	G_OBJECT_CLASS (rygel_default_player_controller_parent_class)->finalize (obj);
#line 2418 "rygel-default-player-controller.c"
}


/**
 * This class keeps track of global states that are not dependant on the
 * RygelMediaPlayer.
 *
 * These states are:
 * # URI
 * # MetaData
 * # Number of tracks
 * # Current track
 * # Playback state
 *
 * In case of playlists this class will also control the player. It needs to
 * proxy the playback state to react on end of item to be able to switch to
 * the next item.
 */
GType rygel_default_player_controller_get_type (void) {
	static volatile gsize rygel_default_player_controller_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_default_player_controller_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelDefaultPlayerControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_default_player_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelDefaultPlayerController), 0, (GInstanceInitFunc) rygel_default_player_controller_instance_init, NULL };
		static const GInterfaceInfo rygel_player_controller_info = { (GInterfaceInitFunc) rygel_default_player_controller_rygel_player_controller_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType rygel_default_player_controller_type_id;
		rygel_default_player_controller_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelDefaultPlayerController", &g_define_type_info, 0);
		g_type_add_interface_static (rygel_default_player_controller_type_id, RYGEL_TYPE_PLAYER_CONTROLLER, &rygel_player_controller_info);
		g_once_init_leave (&rygel_default_player_controller_type_id__volatile, rygel_default_player_controller_type_id);
	}
	return rygel_default_player_controller_type_id__volatile;
}


static void _vala_rygel_default_player_controller_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	RygelDefaultPlayerController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_DEFAULT_PLAYER_CONTROLLER, RygelDefaultPlayerController);
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	switch (property_id) {
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_PLAYER:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_value_set_object (value, rygel_default_player_controller_get_player (self));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_PROTOCOL_INFO:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_value_set_string (value, rygel_default_player_controller_get_protocol_info (self));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_PLAYBACK_STATE:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_value_set_string (value, rygel_player_controller_get_playback_state ((RygelPlayerController*) self));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_N_TRACKS:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_value_set_uint (value, rygel_player_controller_get_n_tracks ((RygelPlayerController*) self));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_TRACK:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_value_set_uint (value, rygel_player_controller_get_track ((RygelPlayerController*) self));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_URI:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_value_take_string (value, rygel_player_controller_get_uri ((RygelPlayerController*) self));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_METADATA:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_value_take_string (value, rygel_player_controller_get_metadata ((RygelPlayerController*) self));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_TRACK_URI:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_value_take_string (value, rygel_player_controller_get_track_uri ((RygelPlayerController*) self));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_TRACK_METADATA:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_value_take_string (value, rygel_player_controller_get_track_metadata ((RygelPlayerController*) self));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_NEXT_URI:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_value_take_string (value, rygel_player_controller_get_next_uri ((RygelPlayerController*) self));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_NEXT_METADATA:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_value_take_string (value, rygel_player_controller_get_next_metadata ((RygelPlayerController*) self));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_CURRENT_TRANSPORT_ACTIONS:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_value_take_string (value, rygel_player_controller_get_current_transport_actions ((RygelPlayerController*) self));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_PLAY_MODE:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		g_value_set_string (value, rygel_player_controller_get_play_mode ((RygelPlayerController*) self));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 2534 "rygel-default-player-controller.c"
		default:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 2540 "rygel-default-player-controller.c"
	}
}


static void _vala_rygel_default_player_controller_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	RygelDefaultPlayerController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, RYGEL_TYPE_DEFAULT_PLAYER_CONTROLLER, RygelDefaultPlayerController);
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
	switch (property_id) {
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_PLAYER:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_default_player_controller_set_player (self, g_value_get_object (value));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_PROTOCOL_INFO:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_default_player_controller_set_protocol_info (self, g_value_get_string (value));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_PLAYBACK_STATE:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_playback_state ((RygelPlayerController*) self, g_value_get_string (value));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_N_TRACKS:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_n_tracks ((RygelPlayerController*) self, g_value_get_uint (value));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_TRACK:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_track ((RygelPlayerController*) self, g_value_get_uint (value));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_URI:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_uri ((RygelPlayerController*) self, g_value_get_string (value));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_METADATA:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_metadata ((RygelPlayerController*) self, g_value_get_string (value));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_TRACK_URI:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_track_uri ((RygelPlayerController*) self, g_value_get_string (value));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_TRACK_METADATA:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_track_metadata ((RygelPlayerController*) self, g_value_get_string (value));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_NEXT_URI:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_next_uri ((RygelPlayerController*) self, g_value_get_string (value));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_NEXT_METADATA:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_next_metadata ((RygelPlayerController*) self, g_value_get_string (value));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		case RYGEL_DEFAULT_PLAYER_CONTROLLER_PLAY_MODE:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		rygel_player_controller_set_play_mode ((RygelPlayerController*) self, g_value_get_string (value));
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 2622 "rygel-default-player-controller.c"
		default:
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 39 "/home/jens/Source/rygel/src/librygel-renderer/rygel-default-player-controller.vala"
		break;
#line 2628 "rygel-default-player-controller.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



